package org.vtokarev.controller;

import org.vtokarev.domain.User;
import org.vtokarev.domain.UserRole;
import org.vtokarev.service.UserService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.time.Instant;
import java.util.Optional;

/**
 * {@code ModifyRoomServlet} class uses for create, edit and delete rooms.
 * It implements {@code doGet} method that processes GET {@code modifyRoom} requests generated by users with ADMIN role.
 * In the {@code doGet} method, it collects the necessary data from the ADMIN request and forwards them to {@code modifyRoom.jsp} view for further processing.
 *
 *  In the {@code doPost} method it implements create, edit, and delete room operations. After the operation is completed it forwards the control to {@code roomList}.
 *
 * @author Vyacheslav Tokarev
 */


@WebServlet(urlPatterns = "/modifyUser", name = "modifyUserServlet")
public class ModifyUserServlet extends HttpServlet {

    private UserService userService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        userService = (UserService) config.getServletContext().getAttribute("app/UserService");

    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        if (req.getParameter("action") == null || req.getParameter("back") == null) {
            resp.sendRedirect("home");
            return;
        }

        if (req.getParameter("action").equals("edit") && req.getParameter("userId") == null) {
            resp.sendRedirect("home");
            return;
        }

        if (req.getParameter("action").equals("create")) {

            req.setAttribute("action", "create");

            if(req.getParameter("firstName") != null) {
                req.setAttribute("firstName", req.getParameter("firstName"));
            }

            if(req.getParameter("lastName") != null) {
                req.setAttribute("lastName", req.getParameter("lastName"));
            }

            if(req.getParameter("email") != null) {
                req.setAttribute("email", req.getParameter("email"));
            }

            if(req.getParameter("userRole") != null) {
                req.setAttribute("userRole", req.getParameter("userRole"));
            }

            if(req.getParameter("errorMessage") != null) {
                req.setAttribute("errorMessage", req.getParameter("errorMessage"));
            }

        } else if (req.getParameter("action").equals("edit")) {
            int userId;
            try {
                userId = Integer.parseInt(req.getParameter("userId"));
            } catch (NumberFormatException e) {
                resp.sendRedirect("home");
                return;
            }
            Optional<User> modifiedUser = userService.get(userId);

            if (modifiedUser.isEmpty()) {
                resp.sendRedirect("home");
                return;
            }

            req.setAttribute("action", "edit");
            req.setAttribute("id", modifiedUser.get().getId());
            req.setAttribute("firstName", modifiedUser.get().getFirstName());
            req.setAttribute("lastName", modifiedUser.get().getLastName());
            req.setAttribute("email", modifiedUser.get().getEmail());
            req.setAttribute("userRole", modifiedUser.get().getUserRole());
            if(req.getParameter("errorMessage") != null)
                req.setAttribute("errorMessage", req.getParameter("errorMessage"));

        }
        req.setAttribute("back", req.getParameter("back"));
        req.getRequestDispatcher("/WEB-INF/jsp/modifyUser.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        if (req.getParameter("action") == null) {
            resp.sendRedirect("home");
            return;
        }
        User currentUser = (User) req.getSession().getAttribute("user");
        boolean isAdmin = currentUser != null && currentUser.getUserRole() == UserRole.ADMIN;
        String requestStr;

        if (isAdmin && "delete".equals(req.getParameter("action"))) {
            userService.delete(Long.parseLong(req.getParameter("userId")));
            resp.sendRedirect("userList");
        } else if (isAdmin && "edit".equals(req.getParameter("action"))) {
            long userId = Long.parseLong(req.getParameter("userId"));
            String firstName = req.getParameter("firstName");
            String lastName = req.getParameter("lastName");
            String email = req.getParameter("email");
            String password = req.getParameter("password");
            UserRole userRole = UserRole.valueOf(req.getParameter("userRole"));
            String errorMessage = userService.getEditErrorMessage(firstName, lastName, email, password);
            if (errorMessage.isBlank()) {
                Optional<User> modifiedUser = userService.get(userId);
                modifiedUser.ifPresent(u -> {
                    u.setFirstName(firstName);
                    u.setLastName(lastName);
                    u.setEmail(email);
                    u.setUserRole(userRole);
                    u.setPassword(password.isBlank() ? "" : userService.sha3_256Hex(password));
                    userService.update(u);
                });
                resp.sendRedirect("userList");
            } else {
                requestStr = "?action=edit&back=userList&firstName=" + firstName +
                        "&lastName=" + lastName + "&email=" + email +
                        "&userRole=" + userRole + "&errorMessage=" + errorMessage;
                resp.sendRedirect("modifyUser" + requestStr);
            }
        } else if ("create".equals(req.getParameter("action"))) {
            String firstName = req.getParameter("firstName");
            String lastName = req.getParameter("lastName");
            String email = req.getParameter("email");
            String password = req.getParameter("password");
            UserRole userRole = isAdmin ? UserRole.valueOf(req.getParameter("userRole")) : UserRole.GUEST;

            String errorMessage = userService.getCreateErrorMessage(firstName, lastName, email, password);

            if (errorMessage.isBlank()) {
                User modifiedUser = new User();
                modifiedUser.setFirstName(firstName);
                modifiedUser.setLastName(lastName);
                modifiedUser.setEmail(email);
                modifiedUser.setPassword(userService.sha3_256Hex(password));
                modifiedUser.setRegDate(Instant.now());
                modifiedUser.setUserRole(userRole);
                userService.create(modifiedUser);
                if (isAdmin) {
                    resp.sendRedirect("userList");
                } else {
                    req.getSession().setAttribute("user", modifiedUser);
                    resp.sendRedirect("home");
                }
            } else {
                requestStr = "?action=create&back=home&firstName=" + firstName +
                        "&lastName=" + lastName + "&email=" + email +
                        "&userRole=" + userRole + "&errorMessage=" + errorMessage;
                resp.sendRedirect("modifyUser" + requestStr);
            }
        }
    }
}
